# The &smb4k; Handbook

Alexander
Reinholdt

              alexander.reinholdt AT kdemail.net

2005-2019
Alexander Reinholdt
&underFDL;
2019-05-19
&smb4k; 3.0.1

&smb4k; is an advanced network neighborhood browser and Samba share mounting utility.

KDE
Smb4K
Samba

## Introduction

This handbook describes &smb4k; 3.0.x and to some extent earlier versions.

&smb4k; is an advanced network neighborhood browser and Samba share mounting utility. It provides many handy features that ease your life in a mostly &Windows;-dominated network environment:

- Scanning for (active) workgroups, hosts, and shares

- Support of the &CIFS; (&Linux;) and SMBFS (BSD) file system

- Mounting and unmounting of shares

- Access to the files of a mounted share using a file manager or terminal

- Auto-detection of external mounts and unmounts

- Remounting of previously used shares on program start

- Miscellaneous infos about remote network items and mounted shares

- Network search

- Preview of the contents of a remote share

- Default login

- Special handling of homes shares

- Ability to bookmark favorite shares

- System tray widget

- Support of advanced mount options

- Support of printer shares

- &kwallet5; support

- Synchronization of a remote share with a local copy and vice versa

- Ability to define custom options for individual servers and shares

- Laptop support through the &solid; hardware device framework

- Wake-On-LAN capabilities

- &plasmoid; for desktop integration

- Profiles for different network neighborhood setups

If you encounter problems while using &smb4k;, please post a help request to our Help forum. In case you find a bug, please report it to our bug tracker. For discussions about &smb4k;-related topics there is the General Discussion forum and we invite every user to participate.

## Using &smb4k;

### Running &smb4k;

You can either launch &smb4k; from the K menu or from &krunner; by typing ``smb4k``. &smb4k; comes with a &plasmoid; for better desktop integration. It can be added as widget to the desktop or panel.

If you are using &Samba; version 4.7 or above, you most likely have to change a setting in &Samba;'s configuration file to make browsing work. Have a look at the Special Remarks section to find out what has to be adjusted.

If the system is missing some of the programs &smb4k; needs to operate properly, it notifies the user:

Screenshot of the missing program notification
The missing program notification

In this case, please install the specified program or, if it is already present, add its location to the `PATH` environment variable in your shell's configuration file (for the bash 1 shell it is the `~/.bashrc` file).

### The Main Window

On the first start-up, the main window of &smb4k; looks similar to the one shown below. The network neighborhood browser (Network Neighborhood) and the mounted shares view (Mounted Shares) are arranged in a tab widget. Above them the menubar and toolbar are located. Below them you find the status bar.

Screenshot of the main window
The main window

&smb4k; comes with a toolbar that contains some of the main actions, like Configure &smb4k; and Quit. It also dynamically loads the actions of the dock widget that currently has got the focus. For additional information, please have a look at the sections discussing the network neighborhood browser and mounted shares view.

The status bar gives some information about the current status of &smb4k;. If the application is processing a user request (&eg; mounting a share), a descriptive message is displayed in the leftmost section and a progress bar is shown with a busy indicator. The two icons on the right hand side indicate if there are shares mounted (network folder icon) and the status of the authentication system (wallet or key icon).

If the dock widgets are arranged as tabs, the user gets additional visual feedback. Each time a share is mounted or unmounted, the Mounted Shares tab is highlighted for a few seconds.

The main window is highly configurable. You can hide or show all tabbed widgets (Settings Dock Widgets). They can also be dragged around with the mouse and docked to different areas in the main window. You can even detach them from the main window. The status bar and the toolbars can be hidden/shown by toggling the menu entry Settings Show Statusbar and the ones under Settings Toolbars Shown, respectively.

### The Network Neighborhood Browser

The interaction with the network neighborhood is done with the Network Neighborhood browser. It contains all network items — &ie; workgroups, servers, and shares — &smb4k; was able to find. They are organized in a network tree, and you can navigate through it by either clicking the control next to the item name or by executing the item itself.

In the network tree, the master browser of each workgroup or domain is highlighted by blue font color. Mounted shares are marked with the respective folder icon and an italic font.

Screenshot of the network neighborhood browser
The network neighborhood browser

The selection of multiple network items is supported. So, it is possible to &eg; mount or preview several shares at once.

#### Browsing

&smb4k; automatically scans the network neighborhood for active workgroups and domains on start-up and presents them in the network neighborhood browser. Opening a workgroup item shows the servers belonging to it. If you want to access the shares of one of the servers, you have to open the desired server.

&smb4k; uses a traditional scan mode, where initially only workgroups and domains are looked up and scans are only made when necessary — &ie; when you execute a network item —.

There is also the possibility to wake up sleeping servers prior to scanning the network neighborhood (Wake-On-LAN). If this feature is enabled, &smb4k; sends a magic package to each server that is to be woken up and waits the defined time until it starts the lookup of the workgroups and domains. The Wake-On-LAN setting can be turned on in the configuration dialog. The servers that should to be woken up have to be defined in the Custom Options dialog.

#### Searching

To search the network neighborhood for shares that contain a certain search item, execute the &Ctrl; F Search action (see also the Actions an Popup Menu section below). The search toolbar opens at the bottom of the network neighborhood browser.

Screenshot of the network neighborhood browser with visible search toolbar
The network neighborhood browser with visible search toolbar

Enter the search term in the line edit and press the &Enter; key or click the Search button. &smb4k; starts to search the entire network neighborhood. When the search finished, all shares matching the search term are highlighted (selected). If you would like to do something with all discovered shares (&eg; mount or preview), you can immediately do this now. Otherwise, you can use the Up and Down buttons to jump to the individual search results. The Clear button can be used to clear the search. To close the search toolbar, press the Close button.

#### Actions and Popup Menu

For the network neighborhood browser several actions are defined. They are present in the menubar under Network, in the toolbar and the popup menu. The following ones are available:

F5 Scan Network|Workgroup|Computer

  Scan the whole network neighborhood, the highlighted workgroup/domain or computer for new entries. This action is visible by default and will be replaced by the Abort action if a network scan is running.

&Ctrl; A Abort

  Abort any running process of the network neighborhood browser. This action is invisible by default and will only be visible instead of the Scan Network|Workgroup|Computer action when a network scan is running.

&Ctrl; F Search

  Search the network neighborhood for a specified search term. Activating this action opens the search toolbar where you can enter the search term and start the search.

&Ctrl; B Add Bookmark

  Add a bookmark to the currently selected remote share. This action is disabled if no share is selected.

  Read the Adding Bookmarks section for more details.

&Ctrl; O Open Mount Dialog

  Open the dialog for mounting shares "manually". This feature may be needed if &smb4k; cannot find a server from which you want to mount a certain shared resource.

&Ctrl; T Authentication

  Open the authentication dialog. You can provide the login and password for the selected server or share. If a workgroup or no item is selected, this action is disabled.

&Ctrl; C Custom Options

  Open the Custom Options dialog. You can set several custom options for the selected server or share. If a workgroup or no item is selected, this menu entry is disabled.

&Ctrl; V Preview

  Preview the contents of the selected remote share. This action is only enabled if a share is selected. Printer shares cannot be previewed.

&Ctrl; P Print File

  Print a file on a remote printer. This action is only available if a printer share is selected.

&Ctrl; M Mount

  Mount the selected remote share. By default and if you clicked anything different than a share with type "Disk" or "IPC", this action is disabled. If you selected a mounted share, this action is replaced by the Unmount action.

&Ctrl; U Unmount

  Unmount the selected share. This action is invisible by default and will only be visible instead of the Mount action when the share is currently mounted.

Although you can interact with the network neighborhood using the keyboard shortcuts mentioned above, in most cases it is more convenient to use the mouse. By right clicking you can open a popup menu. It contains all actions that are available in the network neighborhood browser. Depending on the position where you clicked (on a network item or on the viewport), some of them may be disabled. The figure below shows the popup menu opened on a remote share.

Screenshot of the popup menu of the network neighborhood browser
The popup menu of the network neighborhood browser

#### Tooltips

For each network item a tooltip is provided that contains various information like the name of the workgroup and master browser, the name and IP address of the host, the name of the share, &etc;

The tooltips can be disabled in the configuration dialog.

#### Mounting a Share

There are three options available to mount a remote share:

1. Execute the icon representing the remote share in the network neighborhood browser. (Depending on your &kde; settings, this is done by either single or double clicking the icon.)

2. Select the remote share and click the Mount menu entry. Alternatively, you can press the &Ctrl; M keyboard shortcut.

3. If &smb4k; was not able to find the server where the share is located, you can press the &Ctrl; O Open Mount Dialog menu entry and a mount dialog will be opened:

   Screenshot of the "Mount Share" dialog
   The "Mount Share" dialog

   Here you can enter the location of the share either as Uniform Naming Convention (UNC) address in the form

       //[USER@]SERVER/SHARE

   or

       \\[USER@]SERVER\SHARE

   or as URL in the form

       [smb:]//[user@]server:port/share

   The OK button will be enabled and you can press it to mount the share. However, it is advisable to enter the IP address and the workgroup of the server, too. If you want to add the share to the bookmarks at the same time, tick the Add this share to the bookmarks check box.

Often a share is password protected. In this case, an authentication dialog will appear and you have to enter the correct user name (if not already provided) and password. &smb4k; will proceed mounting the share unless a wrong user name or password was supplied. In that case, the authentication dialog will reappear. If the mount process was successful, the user will be shown a notification and the share will appear in the Mounted Shares view. If mounting fails, a notification with the error message that was returned by mount.cifs 8 (&Linux;) or mount_smbfs 8 (BSD) will be shown.

#### Printing Files on Remote Printers

To print a file on a remote printer, open the print dialog by clicking the printer icon or choosing the &Ctrl; P Print File menu item.

Screenshot of the print dialog
The print dialog

In the Information section various information about the printer is shown. Under File and Settings you have to provide the path to the file you want to print and the desired number of copies. Press Print to start the print process.

&smb4k; currently supports PDF, Postscript, image, and text files. If you try to print a file with an unsupported mimetype, a notification with an error message will appear telling you the mimetype is not supported. In this case you have to convert the file manually to Postscript or PDF and try again.

#### Previewing Shares

&smb4k; provides the ability to preview remote shares. If you click the &Ctrl; V Preview menu entry, the contents of the selected remote share will be opened in a preview dialog.

Screenshot of the preview dialog
The preview dialog

The preview dialog acts like a simple file manager. You can navigate through the contents of the remote share by clicking the folder icons in the list view. You can go one level up by using the Up button and reload the contents of the current folder by pressing the Reload button. The current location is displayed in the combo box on the right hand side. You can also access already visited folders with it.

By default, the preview dialog only shows folders and files that are not hidden. You can change this behavior in the configuration dialog. File transfers or the like are not possible.

#### Providing Authentication Information

Many servers or remote shares are password protected. In that case, a password dialog appears asking you for the user name and password. The same happens, if you click the &Ctrl; T Authentication menu entry.

Screenshot of the authentication dialog
The authentication dialog

If a user name has already been provided, it will be shown in the respective field. If it is wrong or no user name was provided, you have to enter one. The password, however, may be left blank. Clicking the OK button commits the data. Depending on your choice in the configuration dialog, the user name and password will be stored permanently in a digital wallet or not at all. In the latter case you have to provide them every time they are needed.

#### Defining Custom Options

Use the Custom Options dialog if you want to

- define custom mount or Samba options for a single server or share that deviate from the ones defined in the configuration dialog,

- define a server that should be woken up prior to network scans or mount attempts (Wake-On-LAN feature, see here),

- always mount a certain share on start-up or if the corresponding profile is loaded.

The dialog is opened by clicking the &Ctrl; C Custom Options menu entry. Depending on your selection, the settings either apply to all shares of a server or to a single one.

Screenshot of the custom options dialog for a share
The custom options dialog

The Default button is enabled if the entries in the dialog deviate from the settings you defined in the configuration dialog. By clicking it, you can reset the entries in the dialog to their default values. The OK button is enabled if you changed the settings in the dialog. Clicking it will commit the custom settings and close the dialog.

Under BSD, the dialog contains less entries than if you run a different operating system, because several of the options are not supported.

##### Mounting

In this tab you can define settings related to mounting. Checking the Always remount this share button for a selected share leads to it being remounted on every program start. For information about all other settings see here.

##### Samba

You can define the SMB port and if Kerberos should be used for authentication. For detailed information on these settings, please see here.

##### Wake-On-LAN

To make the Wake-On-LAN feature work, you need to provide the MAC address of the server you selected. Currently, &smb4k; has no way to determine the MAC address, so you need to find it out on your own. Afterwards, you can define if &smb4k; should send a magic Wake-On-LAN package to the selected host before the network neighborhood is scanned and/or one of its shares is mounted.

#### Adding Bookmarks

A bookmark is added by selecting a remote share (only these can be bookmarked) and pressing the &Ctrl; B keyboard shortcut or selecting the Add Bookmark menu item. The bookmark will then be accessible through the Bookmarks menu. See the section Bookmarks for more details.

The bookmarks can be used to mount remote shares.

### The Mounted Shares View

In the shares view, you can interact with the mounted shares on your system.

#### Different Views

&smb4k; comes with two alternative views: an icon and a list view. They are both shown below. The default one is the icon view.

The icon view:

Screenshot of the shares icon view
The shares icon view

The list view:

Screenshot of the shares list view
The shares list view

You can switch between the two views by selecting either the appropriate entry in the View Modes submenu from the Shares View menu of the main window or in the shares view's popup menu.

By default, only your own mounts are displayed. However, you can tell &smb4k; to show all mounts by altering the respective settings.

#### Actions and Popup Menu

For the shares view several actions are defined. They are present in the menubar under Shares, the toolbar and in its popup menu. The following ones are available:

View Modes

  Choose the view mode from the submenu.

  Icon View

    The shares are shown in an icon view.

  List View

    The shares are shown in a list view.

&Ctrl; U Unmount

  Unmount one or multiple selected shares. The ability to unmount shares is by default restricted to the ones that are owned by you. However, you can change this behavior by changing the settings in the configuration dialog. If no share is selected in the shares view, this button is disabled.

  &smb4k; also provides the ability to force the unmounting of shares (&Linux; only). This might be useful with inaccessible shares that cannot be unmounted the normal way. To enable this feature, you need to modify the settings in the configuration dialog.

  Read the Unmounting Shares section for more details.

&Ctrl; N Unmount All

  Unmount all shares at once. The restrictions noted above also apply here. If you do not have any shares mounted, this button is disabled.

  Read the Unmounting Shares section for more details.

&Ctrl; B Add Bookmark

  Add a bookmark to the currently selected mounted shares. This action is disabled if no share is selected.

  Read the Adding Bookmarks section for more details.

&Ctrl; Y Synchronize

  Start the synchronization of a share with a local copy or vice versa. This menu entry is only enabled if you installed the program rsync 1 and a share is selected.

&Ctrl; L Open with Konsole

  Open the base folder of a share in &konsole;. This menu item is useful if you need to run shell scripts, &etc;

&Ctrl; I Open with File Manager

  Open the contents of a share in the default file manager.

The popup menu includes all actions that can be performed on a mounted share:

Screenshot of the popup menu of the shares view
The popup menu of the shares view

It can be opened by clicking the right mouse button.

#### Tooltips

The tooltips provide information about the share name, the mount point, the user and group, the login, the file system, the disk usage, and the free disk space. If the share is inaccessible, these values are marked as unknown.

Tooltips are enabled by default. You can deactivate them in the configuration dialog.

#### Inaccessible Shares

&smb4k; periodically checks all mounted shares if they are still accessible. If an inaccessible share is encountered, it will be marked with a locked folder icon and you will not be able to open or synchronize it anymore. Unmounting and adding a bookmark is still possible.

The program might freeze for a short period of time due to an inaccessible share. It will recover afterwards.

#### Icons

Three different icons may be presented to the user:

Screenshot of three different icons
Three different icons

- The icon on the left hand side indicates that this share is not accessible. &smb4k; won't allow you to open it or synchronize it. You will only be able to unmount it or add a bookmark.

- The central icon indicates that the share is online, accessible, and owned by you. You may perform all available actions on it.

- All shares marked with a warning sign like the one on the right hand side are owned by another user. They are only shown if you adjusted the settings to display them. In the default configuration, you are not allowed to unmount these shares, but you can change this behavior, too.

#### Drag-and-Drop

&smb4k; supports drag-and-drop in the shares view. To transfer or link data to a share, drag the files and/or folders over the share icon and drop them there. A popup menu will open asking you what you want to do. Choose the appropriate action (copy, move or link).

Screenshot of the shares view after the user dropped a file
A popup menu opened after the user dropped a file onto a share

To avoid the popup menu, press the &Shift; key for moving, the &Ctrl; key for copying and the &Ctrl;&Shift; key combination for linking while dragging and dropping. The transfer will only be successful if the share was mounted with read and write permissions.

You can also drag and drop the whole share to the desktop or to another application (&eg; &dolphin;). Again, a popup menu will open asking you, what you want to do. When choosing the appropriate operation, please remember that under most circumstances moving and linking the share might not be a good idea.

#### Unmounting Shares

One or multiple selected shares may be unmounted by either clicking the &Ctrl; U Unmount action or by pressing its keyboard shortcut. By default, the ability to unmount a share is restricted to the ones that are owned by you. This behavior can be altered in the configuration dialog. If you enabled the unmounting of shares that are owned by other users, you will be presented with a warning dialog prior to the actual unmount:

Screenshot of the warning dialog that is shown when a foreign share is to be unmounted
The warning dialog that is shown when unmounting foreign shares

If you click the Yes button, the share will definitely be unmounted. So, please think twice before you decide to unmount shares that are owned by other users!

Inaccessible shares are unmounted with a "normal" unmount by default. If this should fail, you can configure &smb4k; so as to perform a lazy unmount on inaccessible shares (&Linux; only).

All shares can be unmounted at once by clicking the &Ctrl; N Unmount All action. Depending on your settings, this will also unmount foreign and inaccessible shares.

After a successful unmount process, the user is notified. If unmounting fails, a notification with the returned error message will be shown.

#### Synchronization

The &Ctrl;Y Synchronize menu item opens the synchronization dialog. It offers you the mount point of the share as source and a path below the synchronization prefix as destination. To update the data on the share, you can swap the destination with the source by clicking the Swap Paths button.

Screenshot of the synchronization input dialog
&URL; requester for sync'ing

Clicking the Synchronize button starts the synchronization. By left clicking on the Notifications button in the system tray, a progress dialog can be opened that shows some details about the transfer.

Screenshot of the synchronization progress dialog
Progress dialog

In the default, collapsed version it displays the source and destination of the file that is currently transferred, the transfer rate and the overall progress. More information like the number of transferred files and a graphical representation of the transfer rate can be seen by clicking the [+] (More) button on the left below to the progress bar.

The synchronization can be paused or canceled at any time by pressing the pause or stop button to the right of the progress bar.

The total number of files that is shown in the progress dialog corresponds to the number of files present on the share and not necessarily to the total number of files that will actually be transferred.

The progress is calculated from the number of transferred files devided by the total number of files present on the share. Their size is not considered. That means that one very large file adds to the progress as much as a very small one does. Also, due to the way rsync displays the transfer progress, the progress bar is only updated after the transfer of the file finished.

#### Opening a Share

&smb4k; provides two possibilities to open a mounted share:

- ##### Open a share with &konsole;

  You can open the mounted share in &konsole; by selecting the &Ctrl;L Open with Konsole action. This is useful if you need to run shell scripts on the share or similar.

- ##### Open a share with the default file manager

  You can open the share in the default file manager (&eg; &dolphin;) by clicking the share icon or selecting the &Ctrl;I Open with File Manager action.

If a share is marked as inaccessible, it cannot be opened.

### The System Tray Widget

#### Location and Usage

When &smb4k; is started, a status icon appears in your system tray. Its status is set to active if workgroups or domains were discovered in your network neighborhood. Otherwise it is set to inactive.

Screenshot of the system tray widget
System tray widget

By left clicking the (active) icon, you can minimize or restore the main window. A right click brings up a popup menu that contains several menu items allowing you to work with the mounted shares, manage or mount your bookmarks, select the profile you want to use and to configure &smb4k; without the need to open the main window.

#### Menus and Menu Items

The Mounted Shares menu lists all mounted shares and some actions that can be performed on them.

Screenshot of the Mounted Shares popup menu of the system tray widget
System tray widget's Mounted Shares menu

Unmount All

  Unmount all shares at once. Depending on your settings, &smb4k; attempts to unmount either only those shares that are owned by you or all that are listed.

For each mounted share you can open a submenu that contains the following entries. For further information read here.

Unmount

  Unmount the share.

Add Bookmark

  Add the selected share to the bookmarks.

Synchronize

  Synchronize the mounted share with a local copy or vice versa. For further information read here and here.

Open with &konsole;

  Open the base folder of the share in &konsole;.

Open with File Manager

  Open the contents of the share in the default file manager (&eg; &dolphin;).

The Bookmarks menu contains all your bookmarks organized according to the structure you gave them (see also here and here).

Screenshot of the Bookmarks menu of the system tray widget
System tray widget's Bookmarks menu

Its layout is as described here except that the Add Bookmark menu item is not present.

In the Profiles menu, all defined profiles are listed:

Screenshot of the Profiles menu of the system tray widget
System tray widget's Profiles menu

You can activate a profile by clicking it. The profiles can be managed via the configuration dialog.

The other menu entries are:

Open Mount Dialog

  Open the dialog for "manual" mounts.

Configure &smb4k;...

  Open the configuration dialog. See here for a full list of available settings.

Minimize | Restore

  Hide (minimize) or show (restore) the main window. Which text is shown depends on the state of the main window.

&Ctrl; Q Quit

  Quit the application.

### The &plasmoid;

&smb4k; comes with a &plasmoid; that can be added as a widget to the desktop or the panel. It consists of five tabs: Network Neighborhood, Mounted Shares, Bookmarks, Profiles, and Configuration.

Screenshot of the plasmoid on the desktop
Screenshot of the plasmoid

#### Network Neighborhood Tab

On the Network Neighborhood page the network items are arranged in a list view:

Screenshot of the plasmoid's network neighborhood tab
Bookmarks tab of the plasmoid

By clicking an entry you either enter the level below (&eg; clicking a workgroup or domain item will show a list of all hosts belonging to it), mount the selected share or invoke the print dialog. To go one level up again, you need to click the Up button in the toolbar.

For hosts and shares, to the right of the name of the network item some action buttons are arranged. For hosts, there is one button with that you can open the Custom Options dialog. For shares, there are additional buttons for previewing the content of the selected share and for adding it to the bookmarks, respectively. The action buttons are transparent by default and change to opaque when you move the mouse over them. By left clicking, you initiate the respective action.

Besides the Up button, the toolbar contains three more entries: Rescan, Abort and Mount Dialog. With them you can do a rescan, abort any running action or open the dialog for "manual" mounts.

#### Mounted Shares Tab

On the Mounted Shares page all mounted shares are listed:

Screenshot of the plasmoid's mounted shares tab
Bookmarks tab of the plasmoid

Right to the name of the share and its host, three action buttons are arranged. The first one is for adding a bookmark, the second for synchronization and the third for unmounting the share. The action buttons are transparent by default and change to opaque when you move your mouse over them. By left clicking you initiate the respective action.

The toolbar only contains the Unmount All action that lets you unmount all shares at once.

#### Bookmarks Tab

On the Bookmarks page, the bookmark groups and bookmarks defined for the currently active profile are listed:

Screenshot of the plasmoid's bookmarks tab
Bookmarks tab of the plasmoid

Bookmarked shares can be mounted by left clicking the respective bookmark. Bookmark groups can be entered the same way.

To edit or remove the bookmarks, you can press the Edit action button in the toolbar to open the Bookmark Editor. To get back to the toplevel the Back button is used.

#### Profiles Tab

On the Profiles page, all defined profiles are listed. The currently active one is marked with an appended (active) label.

Screenshot of the plasmoid's profiles tab
Profiles tab of the plasmoid

You can activate a certain profile by clicking it.

Profiles can be managed via the configuration dialog.

#### Configuration Tab

To configure the behavior of &smb4k;, you can launch the configuration dialog on the Configuration page.

Screenshot of the plasmoid's configuration tab
Configuration tab of the plasmoid

You should not open a configuration dialog through the main application and the &plasmoid; at the same time, because they might interfere with each other.

### Bookmarks

#### Adding Bookmarks

You can add bookmarks to your favorite shares from within the network neighborhood browser, the shares view and the &plasmoid;. In the dock widgets of the main window, this is done by selecting one or multiple shares and clicking the Add Bookmark action. In the &plasmoid;, you click the respective bookmark action next to the item's name. A dialog will then pop up where you can add a label and/or assign a group to the bookmark.

Screenshot of the bookmarks addition dialog
Bookmarks addition dialog

Adding a group may help you to organize the bookmarks. In the bookmark menu, all bookmarks belonging to one group are arranged in a submenu with the group entry as parent (see below).

The label can be any text describing the share. In case you define a label, it will be displayed in the bookmarks menu instead of the location by default. If you want to change this behavior, you can do so in the configuration dialog.

#### Accessing and Managing Bookmarks

In the main window, the bookmarks can be accessed and managed through the Bookmarks menu:

Screenshot of the bookmark popup menu
Bookmark popup menu

In the menu there are two static items available:

Edit Bookmarks

  Open the bookmark editor. This action is disabled if there are no bookmarks.

&Ctrl; B Add Bookmark

  Add bookmarks to the selected shares. At least one share has to be selected to enable this action.

In case you have not defined any groups, there is a third item:

Mount All Bookmarks

  Mount all top-level bookmarks at once. It is disabled if all bookmarked shares are mounted.

All other entries are either group submenus or shares that do not belong to a group. All entries are listed alphabetically and the bookmarks may either appear with their location or descriptive label. By clicking a bookmark, the respective share is mounted. If a bookmarked share is mounted on the system, the bookmark entry is disabled.

For each group there is a submenu. It contains all bookmarks belonging to the group and a Mount All Bookmarks menu item. The latter one can be used to mount all bookmarks in that submenu at once.

In the system tray widget, there is an identical Bookmarks submenu except that the Add Bookmark entry is missing. The plasmoid provides a Bookmarks tab where all bookmarks are arranged in a similar way as in the bookmark menu. The bookmark groups and the bookmarks are listed in the view. Bookmarked shares can be mounted by clicking the respective entry. In the toolbar two actions are present: Back and Edit. By clicking Back you can get back to the top level if you entered a group folder. The Edit action will open the bookmark editor.

#### Editing Bookmarks

The bookmarks may be edited or removed via the bookmark editor. It can be opened by clicking the Edit Bookmarks entry in the Bookmarks menu or the Edit action in the Bookmarks tab of the &plasmoid;.

Screenshot of the bookmark editor
Bookmark editor

In the tree view, the bookmarks are arranged according to the groups they belong to. Bookmarks without groups are located at the top level. To rearrange bookmarks, the tree view offers drag and drop capabilities, so that you can move bookmarks around using the mouse.

If you want to edit a bookmark, you can do so by selecting it. The stored label, login, IP address and group name appear in the input widgets and become editable. In most cases, you do not need to touch the IP address and the login, because &smb4k; stored the correct values at the time you bookmarked the share. However, if the server got a different IP address (&eg; because DHCP is used on your local network) or your login changed, these entries should be adjusted. With the label you can give each bookmark a custom description. It will be used for display instead of the location, but this can be changed in the configuration dialog. The group entry, finally, helps you to organize your bookmarks. Especially if you use &eg; your notebook at home and at work, and you do not want to use profiles, it might be a good idea to create two groups "Home" and "Work" and save the bookmarks accordingly.

The tree view also offers a popup menu containing the following three actions. They can be used to add groups or remove groups and/or bookmarks.

Screenshot of the popup menu of the bookmark editor
Popup menu of the bookmark editor

Add Group

  Add a bookmark group. After you created a group, you can move bookmarks to it.

Remove

  Remove a selected bookmark or group. In case of a group, all bookmarks stored under that group are also removed.

Clear

  Remove all bookmarks from the tree view including all groups.

After you finished editing, the changes can be committed by clicking the OK button.

### Profiles

&smb4k; offers the use of different profiles. They are intended for better handling of different network neighborhoods, &eg; if you are using your laptop at home and at work.

By default, the use of different profiles is disabled and a default profile is used: one profile for everything. Most users won't have to change anything, because the default behavior satisfies their needs completely. However, for some users this feature might be very useful.

#### Enabling and Managing Profiles

The use of different profiles can be enabled in the configuration dialog. The first profile in the list, most likely the Home profile, is picked to be the active profile. You can also enable the profile migration assistant.

Two profiles are pre-defined, Home and Work, but you can define as many profiles as you want. A new profile is added by entering its name into the edit line on the Profiles configuration page and clicking Add afterwards.

Screenshot of the Profiles configuration page (add profile)
Profiles configuration page (add profile)

If you want to rename a profile, just click it and edit the name edit line. Clicking Add will update the name in the list view. All stored settings will be migrated seamlessly (without the use of the migration assistant). A profile can be removed by selecting it in the list view and clicking Remove. There is also the possibility to change the order of the profiles with the Move Up and Move Down buttons.

In case you enabled the use of the migration assistant, it is always launched when you remove a profile or when you enable/disable the use of profiles. It provides the possibility to migrate all relevant settings

- of a profile that is to be removed to another one

- of the default profile to a specific other profile

- of all profiles back to the default profile

The following screenshot shows exemplarily the profile migration assistant after you enabled the use of profiles:

Screenshot of the profile migration assistant
Profile Migration Assistant

Under Old Profile the old profile (<Default Profile> in this case) is listed. Under New Profile you can choose the profile where the settings should be migrated to from a drop-down menu. The first profile in the list is preselected. Clicking the OK button migrates the settings, clicking Cancel cancels the action.

In order to use the migration assistant when you enable the use of profiles the first time, you need to enable its use at the same time you enable the use of profiles.

#### Activating a Profile

By default, the first profile in the list is set active when you enable the use of profiles. The active profile can be changed in the Profiles menu of the main window or the system tray widget or on the Profiles page of the plasmoid.

When a profile is activated, several things happen:

- All currently mounted shares are unmounted and are scheduled for remount.

- All shares are remounted that were previously mounted under the activated profile.

- The bookmarks of this profile are loaded.

- The custom options of this profile are loaded.

So, don't be surprised when things change when you selected a different profile ...

### Notifications

#### Default Behavior

Normal events like mounting and unmounting of a share as well as warnings and errors are reported to the user via system notifications. By default, when the user is notified about a normal event, a notification pops up silently. With warnings and errors also a sound is played. The screenshot below shows the notification that pops up after a share was mounted.

Screenshot of the notification after mounting a share
Notification after mounting a share

The default behavior of each notification can be changed via the &systemsettings;.

#### Managing Notifications

Notifications can be managed via the &systemsettings;. To modify the behavior of a notification, navigate to the Notifications page. Under Event source select the Advanced Network Neighborhood Browser entry from the drop-down menu:

Screenshot of the systemsettings notification module
Systemsettings notification module

All available notifications are shown in the list view and can be edited, enabled and disabled according to your liking.

### Special Remarks

#### Problems Browsing the Network Neighborhood with &Samba; 4.7 and above

Since version 2.9.71, &smb4k; is using &Samba;'s client library (libsmbclient) to browse and search the network neighborhood and print files. With the &Samba; 4.7 release, the default protocol version has been set to SMB3 by the &Samba; team. Unfortunately, &Samba;'s client library cannot handle it correctly at the moment and browsing the network neighborhood will fail. For this reason, users of Samba 4.7 and above need to add the following setting to the [global] section of the `smb.conf` file to force &Samba; to use SMB1 (NT1) and, thus, fix the browsing of the network neighborhood:

    [global]
    ...
    client max protocol = NT1
    ...

If you need help, you can consult the Samba Wiki's User Documentation section for further information.

#### Denied Privilege Escalation

In case the mount and unmount actions fail (most likely with an AuthorizationDeniedError message), your polkit-1 setup might need to be adjusted: Add a file, &eg; named `10-mounthelper.rules`, to the `$PREFIX/etc/polkit-1/rules.d/` directory with the following content:

    polkit.addRule(function(action, subject) {
            if (action.id == "org.kde.smb4k.mounthelper.mount" &&
                subject.isInGroup("wheel")) {
                    return polkit.Result.YES;
            }
    });

    polkit.addRule(function(action, subject) {
            if (action.id == "org.kde.smb4k.mounthelper.unmount" &&
                subject.isInGroup("wheel")) {
                    return polkit.Result.YES;
            }
    });

This allows all users in the Unix group wheel to execute the mount and unmount action. You may adjust the group of authorized users to any group you need (&eg; sudo or operator).

#### Mounting Problems Under BSD

If mounting of password-protected shares from either a &Samba; or a &Windows; server fails, this might be due to the fact that mount_smbfs 8 only uses NTLMv1 authentication and the server does not support it. To fix mounting for a &Samba; server, you can add the following entry to the [global] section of the `smb.conf` file of the server:

    [global]
    ...
    ntlm auth = yes
    ...

To fix this issue for a &Windows; server, please contact the sysadmin and tell her or him that NTLMv1 authentication should be swtiched on (if possible).

#### Other Desktop Environments Than &plasma;

When using a different desktop environment than &plasma;, &Qt; and &kf5; applications might be missing the icons. In that case, you might want to install the application qt5ct (the source code can be obtained here). To use qt5ct with your desktop environment, add the following line to your `~/.xinitrc` or `~/.profile` file:

    export QT_QPA_PLATFORMTHEME=qt5ct

Under NetBSD qt5ct might complain about a missing `libfreetype.so.17` or `libGL.so.2` shared library file and refuse to start. To fix this problem, create the `/etc/ld.so.conf` file and add the path `/usr/X11R7/lib` to it.

## Configuring &smb4k;

This section describes the settings that are available to configure &smb4k;. To open the configuration dialog, you have to click the Configure &smb4k;... menu item.

### User Interface

With the options located here you can change the appearance and behavior of several dialogs and widgets. Please note that if you want to change the appearance of the main window you will find additional options under Settings in the menubar.

Screenshot of the "User Interface" configuration tab
The "Appearance" configuration tab

#### Main Window

Tab orientation

  Define the location of the tabs if the dock widgets in the main window are arranged in tabs. The following values can be chosen:

  Top

    The tabs are located at the top.

  Bottom

    The tabs are located at the bottom.

  Left

    The tabs are located on the left side.

  Right

    The tabs are located on the right side.

  Default: Bottom

Show custom bookmark label if available

  The custom description (label) of the bookmark is shown. It can be defined in the bookmark editor.

  Default: selected

#### Network Neighborhood

Automatically expand domains and hosts

  Automatically expand domain and host items when a list of associated network items (domain members or shares) is added or updated. Please note that a domain or host item will always be expanded when you execute it.

  Default: selected

Show the type of the share

  The type of the shares is shown (i. e. Disk, Printer, or IPC).

  Default: selected

Show the IP address of the server

  The IP address of the remote servers is shown.

  Default: selected

Show the comment

  The comment of a remote server or share is shown.

  Default: selected

Show tooltips for network items

  A tooltip will be shown when you move the mouse pointer over an item in the network neighborhood browser. It contains information about the network item such as the workgroup or domain name, host name, comment, type, &etc;

  Default: selected

#### Shares View

View mode of the shares view

  Define the view mode of the shares view.

  The following modes are defined:

  Icon View

    The icon view mode

  List View

    The list view mode

  Default: Icon View

Show tooltips for mounted shares

  A tooltip will be shown if you move the mouse pointer over an item in the shares view. It contains information about the mounted share such as the share name, UNC address, mount point, owner and group, login (&CIFS; file system, &Linux; only), disk usage, &etc;

  Default: selected

### Network

The options located here influence the network communication. You can modify the behavior of the underlying libsmbclient library in the Samba tab and enable the Wake-On-LAN features in the Wake-On-LAN tab.

Screenshot of the "Network" configuration tab
The "Network" configuration tab

#### Samba

##### Basic Settings

NetBIOS name

  Set the NetBIOS name of your computer. The text box should already be filled with the information found in the `smb.conf` configuration file or with the hostname of your computer. Under normal circumstances there is no need to change anything here.

  Default: NetBIOS name defined in `smb.conf` or the hostname

Domain

  Set the name of the domain/workgroup your computer is in. The text box should already be filled with the information found in the `smb.conf` configuration file. Under normal circumstances there is no need to change anything here.

  Default: domain name defined in `smb.conf`

SMB port

  Enabling this setting sets the remote SMB port number to communicate with a remote host to the value defined in the spin box. Under BSD, this is also the port that is used for mounting.

  Unless you are using a firewall or have a customized network setup, you do not need to change anything here.

  Default: 139

This computer is on a large network neighborhood

  In the default configuration, all available master browsers are queried when the browse list is compiled. On large network neighborhoods this can be very time consuming. Enabling this setting restricts the query to three master browsers.

  Default: not selected

##### Authentication

Master browsers require authentication

  If the workgroup master browsers require authentication to return the browse list, you need to check this button. This may be the case for example with some NAS devices. This setting is rarely needed and might even cause a master browser to return an empty browse list.

  Default: not selected

Use Kerberos for authentication

  Use Kerberos for authentication in an Active Directory environment.

  Default: not selected

Use Winbind ccache for authentication

  Try to use the credentials cached by Winbind.

  Default: not selected

##### Security

Encryption level

  Set the level of encryption that is used to make connections. The following settings can be chosen:

  None

    Encryption is not used.

  Request

    Encryption is requested.

  Require

    Encryption is required.

  Default: None

##### Behavior

Detect printer shares

  Printer shares are detected.

  Default: selected

Detect hidden shares

  Hidden shares are detected. Hidden shares are ending with a $ sign, &eg; Musik$ or IPC$.

  Default: selected

Preview hidden files and directories

  Show all files and directories including the hidden ones when opening a share's contents in the preview dialog.

  Default: not selected

#### Wake-On-LAN

To be able to use the Wake-On-LAN capability of &smb4k;, you have to enable the setting in this section. The hosts that should to be woken up have to be defined through the custom options dialog.

Enable Wake-On-LAN features

  Enable Wake-on-LAN (WOL) features. Wake-On-LAN is an ethernet computer networking standard that allows a computer to be turned on or woken up by a network message. Smb4K uses a magic package send via a UDP socket to wake up remote servers. If you want to take advantage of the Wake-On-LAN feature, you need to enable this option.

  Default: not selected

Waiting time

  This is the waiting time in seconds between the sending of the magic Wake-On-LAN packages and the scanning of the network neighborhood or the mounting of a share.

  Default: 5 s

### Mounting

This configuration page contains all settings regarding the mounting of shares. The settings appearing here are depending on the operation system you are using.

Screenshot of the "Mounting" configuration page
The "Mounting" configuration page

#### Basic Settings

The settings in this tab are the same for all supported operating systems.

##### Directories

Mount prefix

  This is the base folder (mount prefix) where &smb4k; will mount the remote shares. It can be changed by using the &URL; requester (Click the button with the folder icon.) or by directly entering the new path into the text box. Path variables like `$HOME` are recognized.

  Default: `$HOME/smb4k/`

Force generated subdirectories to be lower case

  All subdirectories that are created by &smb4k; below the mount prefix will be lower case.

  Default: not selected

##### Behavior

Remount shares

  Remount all your shares that were mounted when you exited the program or changed a profile. If the remounting of a share fails, Smb4K will retry the next time it is started. Shares that were mounted by other users are ignored.

  This setting does not affect the automatic remounting of shares when your computer woke up from a sleep state.

  Default: not selected

Number of remount attempts

  Set the number of attempts that are made to remount shares before Smb4K gives up.

  Default: 1

Interval between remount attempts

  Set the time that elapses between attempts to remount shares.

  Default: 5 min

Unmount all personal shares on exit

  Unmount all shares that belong to you when the program exits. Shares that are owned by other users are ignored.

  Default: not selected

Force the unmounting of inaccessible shares

  Force the unmounting of inaccessible shares (&Linux; only). In case a share is inaccessible, a lazy unmount is performed. Before the actual unmounting is done, a warning dialog is shown asking to approve the unmount.

  Default: not selected

Allow the unmounting of shares that are owned by other users

  This option will allow you to unmount shares that were mounted by other users.

  USE WITH EXTREME CAUTION!

  Default: not selected

Detect all shares that are mounted on the system

  You will not only see the shares that were mounted and are owned by you, but also all other mounts using the SMBFS (BSD) and &CIFS; (&Linux;) file system that are present on the system.

  Default: not selected

#### Common Mount Settings (&Linux; only)

The Common Mount Settings tab is only available under &Linux;. The settings present under BSD can be found in the Mount Settings (BSD only) section.

##### Common Options

Write access

  Here you can determine if the shares should be mounted read-write or read-only by default. This option is independent of the file mask and the folder mask settings above.

  Default: read-write

Client character set

  Sets the character set used by the client side (&ie; your computer).

  Default: default

File system port

  Sets the file system port number that is used by mount.cifs 8 when mounting a remote share. The default port number (445) should work for all modern operating systems. If you experience problems, try setting the port number to 139. If the problems only occur with a few hosts, it is recommended to leave this option untouched and to use the Custom Options dialog to define individual port numbers for the problematic hosts.

  This option is only available under &Linux;. Under BSD, the port for mounting shares is set with the SMB port option.

  Default: 445

##### &CIFS; Unix Extensions Support

All or most of the servers support the &CIFS; Unix extensions

  Most versions of Samba support the &CIFS; Unix or POSIX extensions. For these servers, some options are not needed, because the right values are negotiated during the mount process. For other servers, you might want to uncheck this option, so that predefined values can be passed to the server. Please note that if your computer is located in a Windows dominated network neighborhood with only a few Samba servers, you can safely uncheck this option and define custom options for the Samba servers.

  Default: not selected

User ID

  Sets the owner of the files and directories on the file system. By default, your UID is used. To change the UID, press the search button and choose one from the drop down menu.

  Default: your UID

Group ID

  Sets the group that owns the files and directories on the file system. By default, your GID is used. To change the GID, press the search button and choose one from the drop down menu.

  Default: your GID

File mode

  Sets the permissions that are applied to files. The value is given in octal and has to have 4 digits. To learn more about the file mode (file_mode), you should read the mount 8 and umask 2 manual pages.

  Default: 0755

Directory mode

  Sets the permissions that are applied to directories. The value is given in octal and has to have 4 digits. To learn more about the directory mode (dir_mode), you should read the mount 8 and umask 2 manual pages.

  Default: 0755

#### Advanced Mount Settings (&Linux; only)

The Advanced Mount Settings tab is only available under &Linux;. The settings present under BSD can be found in the Mount Settings (BSD only) section.

Most of the options you can define here require &Linux; kernel 2.6.15 or later to work.

Definitely assign the UID

  Instruct the client (i.e. your side) to ignore any user ID (UID) provided by the server for files and directories and to always assign the owner to be the value of the transmitted UID.

  Default: not selected

Definitely assign the GID

  Instruct the client (i.e. your side) to ignore any group ID (GID) provided by the server for files and directories and to always assign the owner to be the value of the transmitted GID.

  Default: not selected

Do permission checks

  The client side checks if you have the correct UID and GID to manipulate files and directories on the share. This is in addition to the normal ACL check on the target machine done by the server software. You might want to switch this feature off, if the server(s) support the &CIFS; Unix extensions and you are, hence, not allowed to access the share.

  Default: selected

Attempt to set UID and GID

  If the &CIFS; Unix extensions are negotiated with the server the client side will attempt to set the effective UID and GID of the local process on newly created files, directories, and devices. If this feature is turned off, the default UID and GID defined for the share will be used. It is recommended that you read the manual page of mount.cifs 8 before you change this setting.

  Default: not selected

Use server inode numbers

  Use inode numbers (unique persistent file identifiers) returned by the server instead of automatically generating temporary inode numbers on the client side. This parameter has no effect if the server does not support returning inode numbers or similar. It is recommended that you read the manual page of mount.cifs 8 before you change this setting.

  Default: selected

Translate reserved characters

  Translate six of the seven reserved characters (not backslash, but including the colon, question mark, pipe, asterisk, greater than and less than characters) to the remap range (above 0xF000), which also allows the client side to recognize files created with such characters by &Windows;’s POSIX emulation. This can also be useful when mounting to most versions of Samba. This has no effect if the server does not support Unicode.

  Default: not selected

Do not use locking

  Do not use locking. Do not start lockd.

  Default: not selected

SMB protocol version

  Define which version of the SMB protocol is to be used.

  The following values are allowed:

  1.0 (Classic &CIFS;/SMBv1 protocol)

    The `vers=1.0` command line argument is used. This causes mount.cifs 8 to use the classic &CIFS;/SMBv1 protocol.

  2.0 (Windows Vista SP1/Windows Server 2008)

    The `vers=2.0` command line argument is used. This causes mount.cifs 8 to use the SMBv2.002 protocol. This was initially introduced in Windows Vista Service Pack 1, and Windows Server 2008.

    Note that the initial release version of Windows Vista spoke a slightly different dialect (2.000) that is not supported.

  2.1 (Windows 7/Windows Server 2008R2)

    The `vers=2.1` command line argument is used. This causes mount.cifs 8 to use the SMBv2.1 protocol that was introduced in Microsoft Windows 7 and Windows Server 2008R2.

  3.0 (Windows 8/Windows Server 2012)

    The `vers=3.0` command line argument is used. This causes mount.cifs 8 to use the SMBv3.0 protocol that was introduced in Microsoft Windows 8 and Windows Server 2012.

  3.1.1 (Windows Server 2016)

    The `vers=3.1.1` or `vers=3.11` command line argument is used. This causes mount.cifs 8 to use the SMBv3.1.1 protocol that was introduced in Windows Server 2016.

  Default: 3.0 (Windows 8/Windows Server 2016)

Cache mode

  Define how read and write requests are handled. In case you choose to not cache file data at all, the client never utilizes the cache for normal reads and writes. It always accesses the server directly to satisfy a read or write request. If you choose to follow the &CIFS;/SMB2 protocol strictly, the cache is only trusted if the client holds an oplock. If the client does not hold an oplock, then the client bypasses the cache and accesses the server directly to satisfy a read or write request. Choosing to allow loose caching semantics can sometimes provide better performance on the expense of cache coherency. This option might cause data corruption, if several clients access the same set of files on the server at the same time. Because of this, the strict cache mode is recommended.

  The following values are allowed:

  Do not cache file data at all

    The `cache=none` command line argument is used. This causes mount.cifs 8 to not cache file data at all.

  Follow the &CIFS;/SMB2 protocol strictly

    The `cache=strict` command line argument is used. This causes mount.cifs 8 to follow the &CIFS;/SMB2 protocol strictly.

  Allow loose caching semantics

    The `cache=loose` command line argument is used. This causes mount.cifs 8 to allow loose caching semantics.

  Default: Follow the &CIFS;/SMB2 protocol strictly

Security mode

  Security mode. To be able to use this option, the &CIFS; kernel module 1.40 or later is needed.

  The allowed values are:

  Connect as a null user (no name)

    The `sec=none` command line argument is used. This causes mount.cifs 8 to attempt to connect as a null user (no name).

  Kerberos 5 authentication

    The `sec=krb5` command line argument is used. This causes mount.cifs 8 to use Kerberos version 5 authentication.

  Kerberos 5 authentication and packet signing

    The `sec=krb5i` command line argument is used. This causes mount.cifs 8 to use Kerberos version 5 authentication and force packet signing.

  NTLM protocol

    The `sec=ntlm` command line argument is used. This causes mount.cifs 8 to use NTLM password hashing. Up to &Linux; kernel version 3.8 this is the default setting.

  NTLM protocol and packet signing

    The `sec=ntlmi` command line argument is used. This causes mount.cifs 8 to use NTLM password hashing and force packet signing.

  NTLMv2 protocol

    The `sec=ntlmv2` command line argument is used. This causes mount.cifs 8 to use NTLMv2 password hashing.

  NTLMv2 protocol and packet signing

    The `sec=ntlmv2i` command line argument is used. This causes mount.cifs 8 to use NTLMv2 password hashing and force packet signing.

  NTLMSSP protocol

    The `sec=ntlmssp` command line argument is used. This causes mount.cifs 8 to use NTLMv2 password hashing encapsulated in a Raw NTLMSSP message. Since &Linux; kernel version 3.8 this is the default setting.

  NTLMSSP protocol and packet signing

    The `sec=ntlmssp` command line argument is used. This causes mount.cifs 8 to use NTLMv2 password hashing encapsulated in a Raw NTLMSSP message and force packet signing.

  Default: NTLMSSP protocol

Additional options

  Define additional options for use with mount.cifs 8. Clicking the edit button to the right of the line edit opens an input dialog where the options have to be provided in a comma-separated list. After clicking OK in the input dialog, the options will be checked against a whitelist. All valid entries are accepted and entered into to line edit.

  Default: empty

#### Mount Settings (BSD only)

The Mount Settings tab is only available under FreeBSD, NetBSD and DragonFly BSD. The settings present under &Linux; can be found in the Common Mount Settings (&Linux; only) and Advanced Mount Settings (&Linux; only) sections.

##### Common Options

User ID

  Sets the owner of the files and directories on the file system. By default, your UID is used. To change the UID, press the search button and choose one from the drop down menu.

  Default: your UID

Group ID

  Sets the group that owns the files and directories on the file system. By default, your GID is used. To change the GID, press the search button and choose one from the drop down menu.

  Default: your GID

File mode

  Sets the permissions that are applied to files. The value is given in octal and has to have 4 digits. To learn more about the file mode, you should read the mount_smbfs 8 and umask 2 manual pages.

  Default: 0755

Directory mode

  Sets the permissions that are applied to directories. The value is given in octal and has to have 4 digits. To learn more about the directory mode (dir_mode), you should read the mount_smbfs 8 and umask 2 manual pages.

  Default: 0755

##### Character Sets

Use character sets

  Use the specified local and server's character sets (see below).

  Default: not selected

Client character set

  Use the specified local character set.

  Default: default

Server character set

  Use the specified server's character set.

  Default: default

### Authentication

Here you can change the settings affecting the authentication.

Screenshot of the "Authentication" configuration page
The "Authentication" configuration page

#### Settings

Save logins in a wallet

  The login names and passwords are stored in a subfolder named `Smb4K` of the current network wallet (default: "kdewallet"). The advantage of this method is, that the authentication data is stored permanently and encrypted on your hard drive. You only have to provide it once and the next time it is needed, &smb4k; will read it from the wallet. If you uncheck this option, the authentication data won't be stored at all.

  Default: selected

Use a default login

  The default login is used by default to authenticate to the servers in your network neighborhood. If you enable this feature, a password dialog pops up, where you can provide the default login information.

  Screenshot of the default login input dialog
  The default login input dialog

  You have to fill in at least the user name. Empty passwords are supported.

  Default: not selected

#### Wallet Entries

In this editor you can modify or remove existing wallet entries. Before you can edit them, they have to be loaded from the wallet by pressing the Load button. The list of entries appears then in the left list view. An entry can be edited by selecting it and clicking the Details button on the right. The details are then shown and can be modified.

An entry can be removed by right clicking it and choosing the Remove item from the popup menu. All wallet entries may be removed at once by choosing the Clear List item.

After you finished editing, the changes can be committed to the wallet by pressing Save.

### Synchronization

This configuration page contains options that influence the behavior of the rsync 1 command that is used to synchronize remote shares with local copies and vice versa. It is only available, if rsync 1 is installed on your system. It is recommended that you read the manual page before you use the synchronization feature the first time. However, safe settings are pre-defined. You will do no harm, if you start right away.

Screenshot of the "Synchronization" configuration page
The "Synchronization" configuration page

#### Basic Settings

##### Default Destination

Synchronization prefix

  This is the base folder below which &smb4k; stores the transferred data using rsync 1. It can be changed by using the &URL; requester (Click the button with the folder icon.) or by directly entering the new path into the text box. Path variables like $HOME are recognized.

  For each share you synchronize, a new subdirectory below this prefix will be generated. If you want to synchronize the contents of a share to a different folder, you can define it in the synchronization dialog.

  Default: `$HOME/smb4k_sync/`

##### Behavior

Archive mode

  Option: `-a`/`--archive`, same as `-rlptgoD` (no `-H`)

  Switch the archive mode on. This is a quick way of saying you want recursion and want to preserve almost everything. Note that `-a` does not preserve hardlinks, because finding multiply-linked files is expensive. You must separately specify `-H`.

  Default: selected

Recurse into subdirectories

  Option: `-r`/`--recursive`

  Recurse into subdirectories.

  Default: selected

Use relative path names

  Option: `-R`/`--relative`

  Use relative path names. This means that the full path names specified on the command line are sent to the server rather than just the last parts of the file names.

  Default: not selected

Do not send implied directories

  Option: `--no-implied-dirs`

  This option affects the default behavior of the `--relative` option. When it is specified, the attributes of the implied directories from the source names are not included in the transfer. This means that the corresponding path elements on the destination system are left unchanged if they exist, and any missing implied directories are created with default attributes. This even allows these implied path elements to have big differences, such as being a symlink to a folder on one side of the transfer, and a real folder on the other side.

  For further information you ought to read the manual page.

  Default: not selected

Transfer directories without recursing

  Option: `-d`/`--dirs`

  Tell the sending side to include any directories that are encountered. Unlike `--recursive`, a folders contents is not copied unless the folder name specified is "." or ends with a trailing slash (&eg; ".", "dir/.", "dir/", &etc;). Without this option or the `--recursive` option, rsync 1 will skip all directories it encounters (and output a message to that effect for each one). If you specify both `--dirs` and `--recursive`, `--recursive` takes precedence.

  Default: not selected

##### Backup

Make backups

  Option: `-b`/`--backups`

  With this option, preexisting destination files are renamed as each file is transferred or deleted. You can control where the backup file goes and what (if any) suffix gets appended using the `--backup-dir` and `--suffix` options.

  Note that if you don't specify `--backup-dir`, (1) the `--omit-dir-times` option will be implied, and (2) if `--delete` is also in effect (without `--delete-excluded`), rsync 1 will add a "protect" filter-rule for the backup suffix to the end of all your existing excludes (&eg; `-f "P *~"`). This will prevent previously backed-up files from being deleted. Note that if you are supplying your own filter rules, you may need to manually insert your own exclude/protect rule somewhere higher up in the list so that it has a high enough priority to be effective (&eg;, if your rules specify a trailing inclusion/exclusion of '*', the auto-added rule would never be reached).

  Default: not selected

Backup suffix

  Option: `--suffix=SUFFIX`

  This option allows you to override the default backup suffix used with the `--backup` option. The default suffix is a ~ if no `--backup-dir` was specified, otherwise it is an empty string.

  This option is only available if you ticked the Make backups option above.

  Default: not selected; SUFFIX: ~

Backup directory

  Option: `--backup-dir=DIR`

  In combination with the `--backup` option, this tells rsync to store all backups in the specified folder. This is very useful for incremental backups. You can additionally specify a backup suffix using the `--suffix` option (otherwise the files backed up in the specified folder will keep their original filenames).

  This option is only available if you ticked the Make backups option above.

  Default: not selected; DIR: `$HOME`

#### File Handling

##### General

Update files

  Option: `-u`/`--update`

  This forces rsync 1 to skip any files that exist on the destination and have a modification time that is newer than the one of the source file. (If an existing destination file has a modification time equal to the source file's, it will be updated if the sizes are different.)

  Default: selected

Update files in place

  Option: `--inplace`

  This causes rsync 1 not to create a new copy of the file and then move it into place. Instead rsync 1 will overwrite the existing file, meaning that the rsync algorithm cannot accomplish the full amount of network reduction it might be able to otherwise. One exception to this is if you combine the option with `--backup`, since rsync 1 is smart enough to use the backup file as the basis file for the transfer.

  For further information you ought to read the manual page.

  Default: not selected

Handle sparse files efficiently

  Option: `-S`/`--sparse`

  Try to handle sparse files efficiently so they take up less space on the destination. Conflicts with `--inplace` because it's not possible to overwrite data in a sparse fashion.

  Do not use this option when the destination is a &Solaris; "tmpfs" file system. It doesn't seem to handle seeks over null regions correctly and ends up corrupting the files.

  Default: not selected

Copy files whole (no rsync algorithm)

  Option: `-W`/`--whole-file`

  With this option the incremental rsync 1 algorithm is not used and the whole file is sent as-is instead. The transfer may be faster if this option is used when the bandwidth between the source and destination machines is higher than the bandwidth to disk (especially when the "disk" is actually a networked file system). This is the default when both the source and destination are specified as local paths.

  Default: not selected

Only update files that already exist

  Option: `--existing`/`--ignore-non-existing`

  This tells rsync 1 to skip updating files that do not exist yet on the destination. If this option is combined with the `--ignore-existing` option, no files will be updated (which can be useful if all you want to do is to delete missing files).

  Default: not selected

Ignore files that already exist

  Option: `--ignore-existing`

  This tells rsync 1 to skip updating files that already exist on the destination. See also `--ignore-non-existing`.

  Default: not selected

##### Links

Preserve symlinks

  Option: `-l`/`--links`

  Copy symlinks as symlinks.

  Default: selected

Transform symlinks

  Option: `-L`/`--copy-links`

  When symlinks are encountered, the item that they point to is copied, rather than the symlink.

  Default: not selected

Transform unsafe symlinks

  Option: `--copy-unsafe-links`

  Only transform "unsafe" symlinks. This means if a symlink is encountered that is pointing outside the copied tree, the referenced item is transferred rather than the symlink itself.

  Default: not selected

Ignore unsafe symlinks

  Option: `--safe-links`

  This tells rsync 1 to ignore any symbolic links which point outside the copied tree. All absolute symlinks are also ignored. Using this option in conjunction with `--relative` may give unexpected results.

  Default: not selected

Munge symlinks

  Option: `-H`/`--munge-links`

  This tells rsync 1 to (1) modify all symlinks on the receiving side in a way that makes them unusable but recoverable, or (2) to unmunge symlinks on the sending side that had been stored in a munged state. This is useful if you do not quite trust the source of the data to not try to slip in a symlink to an unexpected place. For further information on this argument, please see the manual page of rsync 1.

  Default: not selected

Preserve hard links

  Option: `-H`/`--hard-links`

  This tells rsync 1 to look for hard-linked files in the transfer and link together the corresponding files on the receiving side. Without this option, hard-linked files in the transfer are treated as though they were separate files.

  Note that rsync 1 can only detect hard links if both parts of the link are in the list of files being sent.

  Default: not selected

Copy directory symlinks

  Option: `-k`/`--copy-dirlinks`

  This option causes the sending side to treat a symlink to a directory as though it were a real directory. This is useful if you don’t want symlinks to non-directories to be affected, as they would be using `--copy-links`.

  Default: not selected

Keep directory symlinks

  Option: `-K`/`--keep-dirlinks`

  This option causes the receiving side to treat a symlink to a directory as though it were a real directory, but only if it matches a real directory from the sender. Without this option, the receiver's symlink would be deleted and replaced with a real directory.

  Default: not selected

##### Permissions, &etc;

Preserve permissions

  Option: `-p`/`--perms`

  This option causes the receiving side to set the destination permissions to be the same as the source permissions.

  Default: selected

Preserve owner

  Option: `-o`/`--owner`

  This option causes rsync 1 to set the owner of the destination file to be the same as the one of the source file. By default, the preservation is done by name, but may fall back to using the ID number in some circumstances (see the `--numeric-ids` option for a full discussion). This option has no effect if the receiving rsync 1 is not run as the super user and `--super` is not specified.

  Default: selected

Preserve group

  Option: `-g`/`--group`

  This option causes rsync 1 to set the group of the destination file to be the same as the on of the source file. If the receiving program is not running as the super-user (or with the `--no-super` option), only groups that the receiver is a member of will be preserved.

  Default: selected

Preserve device and special files

  Option: `-D`/`--devices --specials`

  This option causes rsync 1 to transfer character and block device files as well as special files (such as named sockets and fifos) to the remote system. This option has no effect if the receiving side is not run as the super user and `--super` is not specified.

  Default: selected

Preserve times

  Option: `-t`/`--times`

  This tells rsync 1 to transfer modification times along with the files and update them on the remote system.

  Default: selected

Omit directories when preserving times

  Option: `-O`/`--omit-dir-times`

  This tells rsync 1 to omit directories when it is preserving modification times (see `--times`).

  Default: not selected

#### File Transfer

##### Compression

Compress data during transfer

  Option: `-z`/`--compress`

  Compress file data during the transfer.

  Default: not selected

Set compression level

  Explicitly set the compression level to use (--compress-level=NUM). If NUM is non-zero, the --compress argument is implied.

Skip compression for following file suffixes

  Overwrite the list of file suffixes that will not be compressed (--skip-compress=LIST). The LIST should be one or more file suffixes (without the dot) separated by slashes. You may specify an empty string to indicate that no file should be skipped. The default list of suffixes will be replaced by this list. For further details, see the manual page of rsync.

##### Files

Do not transfer any file smaller than

  Option: `--min-size=NUM`

  This tells rsync 1 to avoid transferring any file that is smaller than the specified SIZE, which can help in not transferring small, junk files.

  Default: not selected; NUM: 0 kB

Do not transfer any file larger than

  Option: `--max-size=NUM`

  This tells rsync 1 to avoid transferring any file that is larger than the specified SIZE.

  Default: not selected; NUM: 0 kB

Keep partially transferred files

  Option: `--partial`

  By default, rsync 1 will delete any partially transferred file if the transfer is interrupted. In some circumstances it is more desirable to keep partially transferred files. Using the `--partial` option tells rsync 1 to keep the partial file which should make a subsequent transfer of the rest of the file much faster.

  Default: not selected

Put partially transferred files into

  Option: `--partial-dir=DIR`

  A better way to keep partial files than the `--partial` option is to specify a folder DIR that will be used to hold the partial data (instead of writing it out to the destination file). On the next transfer, rsync 1 will use a file found in this folder as data to speed up the resumption of the transfer and then delete it after it has served its purpose. Before you tick this option, you should read the manual page.

  Default: not selected; DIR: `$HOME`

##### Miscellaneous

Set bandwidth limit:

  Option: `--bwlimit=RATE`

  Set the maximum data transfer rate in kilobytes per second.

  Default: not selected; RATE: 0 KiB/s

#### File Deletion

##### Files & Directories

Remove synchronized source files

  Option: `--remove-source-files`

  This tells rsync 1 to remove from the sending side the files (meaning non-directories) that are a part of the transfer and have been successfully duplicated on the receiving side.

  Default: not selected

Delete extraneous files

  Option: `--delete`

  This tells rsync 1 to delete extraneous files from the receiving side (ones that aren't on the sending side), but only for the directories that are being synchronized. You must have asked rsync 1 to send the whole folder (&eg; "`dir`" or "`dir/`") without using a wildcard for the folders contents (&eg; "`dir/*`") since the wildcard is expanded by the shell and rsync 1 thus gets a request to transfer individual files, not the files' parent folder. Files that are excluded from transfer are also excluded from being deleted unless you use the `--delete-excluded` option or mark the rules as only matching on the sending side.

  Default: not selected

Delete files before transfer

  Option: `--delete-before`

  Request that the file deletions on the receiving side be done before the transfer starts. This is the default if `--delete` or `--delete-excluded` is specified without one of the `--delete-WHEN` options.

  Default: not selected

Delete files after transfer

  Option: `--delete-after`

  Request that the file deletions on the receiving side be done after the transfer has completed.

  Default: not selected

Delete files during transfer

  Option: `--delete-during`

  Request that the file deletions on the receiving side be done incrementally as the transfer happens. This is a faster method than choosing the before- or after-transfer algorithm, but it is only supported beginning with rsync 1 version 2.6.4.

  Default: not selected

Delete excluded files

  Option: `--delete-excluded`

  In addition to deleting the files on the receiving side that are not on the sending side, this tells rsync 1 to also delete any files on the receiving side that are excluded (see `--exclude`).

  Default: not selected

Delete even if I/O errors occur

  Option: `--ignore-errors`

  Tells `--delete` to go ahead and delete files even when there are I/O errors.

  Default: not selected

Force deletion of non-void directories

  Option: `--force`

  This option tells rsync 1 to delete a non-empty folder when it is to be replaced by a non-folder. This is only relevant if deletions are not active (see `--delete`).

  Default: not selected

##### Restrictions

Do not delete more than this many files

  Option: `--max-delete=NUM`

  This tells rsync 1 not to delete more than NUM files or directories (NUM must be non-zero). This is useful when mirroring very large trees to prevent disasters.

  Default: not selected; NUM: 0

#### Filtering

##### General

Auto-ignore files in the same way CVS does

  Option: `-C`/`--cvs-exclude`

  This is a useful shorthand for excluding a broad range of files that you often don't want to transfer between systems. It uses the same algorithm that CVS uses to determine if a file should be ignored.

  Default: not selected

Exclude files matching this pattern

  Option: `--exclude=PATTERN`

  This option is a simplified form of the `--filter` option that defaults to an exclude rule and does not allow the full rule-parsing syntax of normal filter rules.

  Default: not selected; PATTERN: empty

Read exclude patterns from

  Option: `--exclude-from=FILE`

  This option is related to the `--exclude` option, but it specifies a FILE that contains exclude patterns (one per line). Blank lines in the file and lines starting with ';' or '#' are ignored. You have to choose an existing file to make this option work.

  Default: not selected; FILE: `$HOME/exclude.txt`

Include files matching this pattern

  Option: `--include=PATTERN`

  This option is a simplified form of the `--filter` option that defaults to an include rule and does not allow the full rule-parsing syntax of normal filter rules.

  Default: not selected; PATTERN: empty

Read include patterns from

  Option: `--include-from=FILE`

  This option is related to the `--include` option, but it specifies a FILE that contains include patterns (one per line). Blank lines in the file and lines starting with ';' or '#' are ignored. You have to choose an existing file to make this option work.

  Default: not selected; FILE: `$HOME/include.txt`

##### Filter Rules

Custom filter rules

  Option: `-f`/`--filter=RULE`

  You can define one or more filter rules here. Each rule has to be prefixed with the `--filter=` or `-f` option string, because the contents of the text box will be passed to the rsync 1 command AS IS.

  This option allows you to add rules to selectively exclude certain files from the list of files to be transferred. This is most useful in combination with a recursive transfer.

  You may use as many `--filter` options as you like to build up the list of files to exclude.

  See the FILTER RULES section of the manual page for detailed information on this option.

  Default: empty

Use --filter='dir-merge /.rsync-filter' filter rule

  Option: `-F`

  This option tells rsync 1 to look for per-folder `.rsync-filter` files that have been sprinkled through the hierarchy and use their rules to filter the files in the transfer.

  See the FILTER RULES section of the manual page for detailed information on how this option works.

  Default: not selected

Use --filter='exclude .rsync-filter' filter rule

  Option: `-FF`

  This option filters out the `.rsync-filter` files themselves from the transfer.

  See the FILTER RULES section of the manual page for detailed information on how this option works.

  Default: not selected

#### Miscellaneous

##### Checksums

Force fixed checksum block size

  Option: `-B`/`--block-size=SIZE`

  This forces the block size used in the rsync algorithm to a fixed value. It is normally selected based on the size of each file being updated. See the technical report for details.

  Default: not selected; SIZE: 0

Set block/file checksum seed

  Option: `--checksum-seed=NUM`

  Set the MD4 checksum seed to the integer NUM. This 4 byte checksum seed is included in each block and file MD4 checksum calculation. By default the checksum seed is generated by the server and defaults to the current time(). This option is used to set a specific checksum seed, which is useful for applications that want repeatable block and file checksums, or in the case where the user wants a more random checksum seed. Note that setting NUM to 0 causes rsync to use the default of time() for checksum seed.

  Default: not selected; NUM: 0

Skip files based on checksum

  Option: `-c`/`--checksum`

  This forces the sender to checksum every regular file using a 128-bit MD4 checksum. It does this during the initial file system scan as it builds the list of all available files. The receiver then checksums its version of each file (if it exists and it has the same size as its sender-side counterpart) in order to decide which files need to be updated: files with either a changed size or a changed checksum are selected for transfer. Since this whole-file checksumming of all files on both sides of the connection occurs in addition to the automatic checksum verifications that occur during a file's transfer, this option can be quite slow.

  Default: not selected

##### General

Do not cross file system boundaries

  Option: `-x`/`--one-file-system`

  This tells rsync 1 to avoid crossing a file system boundary when recursing. This does not limit the user's ability to specify items to copy from multiple file systems, just rsync 1's recursion through the hierarchy of each folder that the user specified, and also the analogous recursion on the receiving side during deletion. Also keep in mind that rsync 1 treats a "bind" mount to the same device as being on the same file system.

  Default: not selected

Delay updates until the end of transfer

  Option: `--delay-updates`

  This option puts the temporary file from each updated file into a holding folder until the end of the transfer, at which time all the files are renamed into place in rapid succession.

  It is strongly recommended that you read the manual page before using this option.

  Default: not selected

### Custom Options

All servers and shares for which you defined custom options are listed here.

Screenshot of the "Custom Options" configuration tab
The "Custom Options" configuration tab

The options defined for a network item can be edited by either double clicking an entry in the list view or by choosing the Edit item from the popup menu (right click on the selected item). The custom options are then being loaded and can be edited. To remove an entry, right click it and choose the Remove item from the popup menu. All network items may be removed at once by choosing the Clear List item.

The custom options are accessible through the tabs on the right.

#### Network Item

This tab mostly serves as resource of information. In the Identification groupbox the workgroup or domain of the network item, its location and IP address are given. The IP address can be edited, in case you might need to adjust it.

#### Mounting

Here you can edit settings used for mounting. Have a look at the Mounting configuration page to learn more about the present options.

#### Samba

You can edit various Samba settings here. Which ones are available depends on the operating system you are using. For more information, have a look at the &Samba; settings.

#### Wake-On-LAN

Here you can edit the options that you previously defined through the Custom Options dialog.

### Profiles

On this page you can enable the use of profiles and manage your profiles.

Screenshot of the "Profiles" configuration tab
The "Profiles" configuration tab

#### Settings

Use profiles

  Make Smb4K use profiles. This enables you to define different bookmarks and custom options for each profile. This is especially useful if you are using a laptop in different network neighborhoods, &eg; at home and at work. When enabling this setting the first time, the first entry in the profiles list will be the active profile.

  Default: not selected

Use profile migration assistant

  Use the profile migration assistant when profiles are removed or the use of profiles is enabled or disabled. The profile migration assistant allows you to migrate all settings that were saved for a certain profile to a different one.

  Default: not selected

#### Profiles

Here, you can manage your profiles. By default, there are two pre-defined ones (Home and Work), but you can add your own ones. When you enabled the use of profiles the first time, the first entry in the list will be the active profile.

When you rename a profile, the settings are migrated automatically (without showing the migration assistant). If you enabled the use of the migration assistant, it is shown when you remove a profile giving you the opportunity to migrate the stored settings to another profile. If the use of the migration assistant is disabled, the profile and all of its settings are removed.

## Command Reference

### The File Menu

File Profiles

  Select the profile to use. This menu entry is disabled if the user did not enabled the use of profiles.

  Two profiles are predefined:

  File Profiles Home

    A profile for use at home

  File Profiles Work

    A profile for use at work

&Ctrl; Q File Quit

  Quit &smb4k;.

### The Network Menu

F5 Network Scan Network|Workgroup|Computer

  Scan the whole network neighborhood, the highlighted workgroup/domain or computer for new entries. This action is visible by default and will be replaced by the Abort action if a network scan is running.

&Ctrl; A Network Abort

  Abort any running process of the network neighborhood browser. This action is invisible by default and will only be visible instead of the Scan Network|Workgroup|Computer action when a network scan is running.

&Ctrl; F Network Search

  Open the search toolbar in the network neighborhood browser.

Network Add Bookmark

  Add a bookmark to the currently selected remote share. This action is disabled if no share is selected. Read the Adding Bookmarks section for more details.

&Ctrl; O Network Open Mount Dialog

  Open the dialog for mounting shares "manually". This feature may be needed if &smb4k; cannot find a server from which you want to mount a certain shared resource.

&Ctrl; T Network Authentication

  Open the authentication dialog. You can provide the login and password for the selected server or share. If a workgroup or no item is selected, this action is disabled.

&Ctrl; C Network Custom Options

  Open the Custom Options dialog. You can set several custom options for the selected server or share. If a workgroup or no item is selected, this menu entry is disabled.

&Ctrl; V Network Preview

  Preview the contents of the selected remote share. This action is only enabled if a share is selected. Printer shares cannot be previewed.

&Ctrl; P Network Print File

  Print a file on a remote printer. This action is only available if a printer share is selected.

&Ctrl; M Network Mount

  Mount the selected remote share. By default and if you clicked anything different than a share with type "Disk" or "IPC", this action is disabled. If you selected a mounted share, this action is replaced by the Unmount action.

&Ctrl; U Network Unmount

  Unmount the selected share. This action is invisible by default and will only be visible instead of the Mount action when the share is currently mounted.

### The Shares Menu

Shares View Modes

  Choose the view mode from the submenu.

  Shares View Modes Icon View

    The shares are shown in an icon view.

  Shares View Modes List View

    The shares are shown in a list view.

&Ctrl; U Shares Unmount

  Unmount one or multiple selected shares. The ability to unmount shares is by default restricted to the ones that are owned by the user. However, you can change this behavior by changing the settings in the configuration dialog. If no share is selected in the shares view, this button is disabled.

  &smb4k; also provides the ability to force the unmounting of shares (&Linux; only). This might be useful with inaccessible shares that cannot be unmounted the normal way. To enable this feature, you need to modify the settings in the configuration dialog.

  Read the Unmounting Shares section for more details.

&Ctrl; N Shares Unmount All

  Unmount all shares at once. The restrictions noted above also apply here. If you do not have any shares mounted, this button is disabled.

Shares Add Bookmark

  Add a bookmark to the currently selected mounted share. This action is disabled if no share is selected. Read the Adding Bookmarks section for more details.

&Ctrl; Y Shares Synchronize

  Start the synchronization of a share with a local copy or vice versa. This menu entry is only enabled if you installed the program rsync 1 and a share is selected.

&Ctrl; L Shares Open with Konsole

  Open the base folder of the selected share in &konsole;.

&Ctrl; I Shares Open with File Manager

  Open the contents of the selected share in the default file manager (&eg; &dolphin;).

### The Bookmarks Menu

Bookmarks Edit Bookmarks

  Open the bookmark editor. This action is disabled if there are no bookmarks.

&Ctrl; B Bookmarks Add Bookmark

  Add one or several bookmarks. At least one share has to be selected to enable this action.

Bookmarks Mount All Bookmarks

  Mount all top-level bookmarks at once. It is disabled if all bookmarked shares are mounted. This action is not present if there are no toplevel bookmarks.

### The Settings Menu

Settings Toolbars Shown

  In this submenu you can enable or disable the toolbars.

Settings Show Statusbar

  Hide or show the status bar.

Settings Dock Widgets

  Hide or show the dock widgets in the main window.

Settings Configure &smb4k;...

  Open the configuration dialog.

### The Help Menu

Additionally &smb4k; has the common &kde; Help menu items, for more information read the section about the Help Menu of the &kde; Fundamentals.

## Reporting Bugs

Before filing a bug report, please try the latest version of &smb4k;. Maybe your problem has already been fixed.

Follow these directions for your bug report:

- Describe in detail what you did to receive the problem you are reporting.

- Provide the version of &smb4k; and &kf5;.

- Mention your operating system (&Linux;, FreeBSD, &etc;) and the distribution that is running on your computer.

- Include the full error message if an error dialog was displayed.

- If you experienced a crash, attach a full backtrace. For this it is recommended that you (re-)compile &smb4k; with debugging symbols. How this is done is mentioned in the Configuration, Compilation and Installation chapter in the appendix.

- Add additional data, &eg; send a screen shot if you are reporting a &GUI; related problem.

The recommended method to report a bug is to use the dialog that opens when you click the Help Report Bug... menu item. But you can also go directly to the KDE Bugtracking System and fill out the form.

## Credits and License

Copyright © 2003 - 2019, Alexander Reinholdt alexander.reinholdt@kdemail.net

&underFDL; &underGPL;

### Developers

- Alexander Reinholdt alexander.reinholdt@kdemail.net

### Translations

Translations were contributed by the &kde; translators.

### Special Thanks

The &smb4k; team would like to thank everyone who contributed by sending patches. Also, a big "Thank you!" goes to Rashid N. Achilov shelton@sentry.granch.ru, who convinced us to port &smb4k; to FreeBSD and helped us a great deal to achieve this goal.

## Appendix

### How to obtain &smb4k;

The latest stable release is available at https://sourceforge.net/projects/smb4k/files/.

### Requirements

&smb4k; officially supports &Linux;, FreeBSD, NetBSD and DragonFly BSD. Other operating systems might work as well, but haven't been tested.

To compile &smb4k;, you need:

- CMake (≥ 3.2)

- GNU Compiler Collection (g++ ≥ 5.0) or clang/LLVM (≥ 3.0)

To be able to use the main application of &smb4k;, you need at least &Qt; version 5.6.0 and &kf5; version 5.25.0 to be installed. The provided &plasmoid; is known to run with &Qt; version 5.6.1, &kf5; version 5.36 and &plasma; version 5.8.9. Earlier versions of &kf5; and &plasma; might work as well but have not been tested.

&smb4k; build depends on:

- QtCore, QtGui, QtWidgets, QtTest, QtNetwork, QtPrintSupport, QtQml

- KConfig, KAuth, KDocTools, KIconThemes, KWidgetsAddons, KI18n, KCompletion, KCoreAddons, &solid;, KIO, KNotifications, KXmlGui, KJobWidgets, &kwallet5;, KDBusAddons, KConfigWidgets, KNotifications, KWindowSystem

- libsmbclient

It also runtime depends on:

- KPlasma

- LinuxCIFS utils (&Linux; only)

To enable full functionality, you may also want to install these programs:

- rsync

The full list of changes can be found in the Git log at cgit.kde.org. A summary can be found in the `ChangeLog` file in the tarball.

### Configuration, Compilation and Installation

This section describes the configuration, compilation and installation of &smb4k;. Make sure, you have read the Requirements section before you start.

Download the version of &smb4k; you are interested in and extract the source tarball:

    $ tar xvfJ smb4k-x.y.z.tar.xz

Replace x.y.z with the version number. Change into the source code directory and create a `build` directory:

    $ cd smb4k-x.y.z
    $ mkdir build

Change into the `build` directory and configure the source code:

    $ cd build
    $ cmake -DCMAKE_INSTALL_PREFIX=`qtpaths --install-prefix` -DCMAKE_BUILD_TYPE=Release ..

If &smb4k; cannot find some shared libraries after the installation (&eg; if you are using Kubuntu 16.04), it may be necessary to add the `-DKDE_INSTALL_PLUGINDIR` argument to the command line above:

    $ cd build
    $ cmake -DCMAKE_INSTALL_PREFIX=`qtpaths --install-prefix` \
         -DKDE_INSTALL_PLUGINDIR=`qtpaths --plugin-dir` -DCMAKE_BUILD_TYPE=Release ..

If you want to compile &smb4k; with debug symbols, replace Release by Debug. You should consider this if you experience &ie; a crash and want to either debug &smb4k; yourself or report a bug including a full backtrace.

There are also some &smb4k; specific arguments you might be interested in:

Argument | Since | Description
--- | --- | ---
-DINSTALL_HEADER_FILES=ON|OFF | 1.0.0 | Install the core header files. This is off by default.
-DINSTALL_PLASMOID=ON|OFF | 1.1.0 | Install the plasmoid. This is on by default.

After the configuration, compile and install &smb4k;:

    $ make && sudo make install

If you want to be able to remove &smb4k; with your package manager later on, use checkinstall instead of `make install`. The package should be present in your distribution's repository. Run:

    $ make && sudo checkinstall